
#include <stdio.h>

int main(int argc, char **argv)
{
	char line[1024];

	if ((argc > 1) && (strcmp(argv[1], "-c") == 0))
	{
		int i;
		int first = 1;
		unsigned long n;

		for (i = 2; i < argc; i++)
		{
			if (sscanf(argv[i], "%lx", &n) == 0)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("XX");
			}
			else if (n < 0x80)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("%02lX", n);
			}
			else if (n < 0x800)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("%02lX %02lX", (0xC0 | (n >> 6)), (0x80 | (n & 0x3F)));
			}
			else if (n < 0x10000)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("%02lX %02lX %02lX", (0xE0 | (n >> 12)), (0x80 | ((n >> 6) & 0x3F)), (0x80 | (n & 0x3F)));
			}
			else if (n < 0x200000)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("%02lX %02lX %02lX %02lX", (0xF0 | (n >> 18)), (0x80 | ((n >> 12) & 0x3F)), (0x80 | ((n >> 6) & 0x3F)), (0x80 | (n & 0x3F)));
			}
			else
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("XX");
			}
		}

		printf("\n");
		return 0;
	}
	else if ((argc > 1) && (strcmp(argv[1], "-e") == 0))
	{
		int i = 2;
		int first = 1;
		unsigned long b0;
		unsigned long b1;
		unsigned long b2;

		while (i < argc)
		{
			if (sscanf(argv[i++], "%lx", &b0) == 0)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("XXXX");
			}
			else if ((b0 & 0x80) == 0)
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("%04lX", b0);
			}
			else if ((b0 & 0xE0) == 0xC0)
			{
				if ((i >= argc) || (sscanf(argv[i++], "%lx", &b1) == 0))
				{
					if (first) { first = 0; } else { printf(" "); }
					printf("XXXX");
				}
				else
				{
					if (first) { first = 0; } else { printf(" "); }
					printf("%04lX", ((b0 & 0x1F) << 6) | (b1 & 0x3F));
				}
			}
			else if ((b0 & 0xF0) == 0xE0)
			{
				if ((i >= argc) || (sscanf(argv[i++], "%lx", &b1) == 0) || (i >= argc) || (sscanf(argv[i++], "%lx", &b2) == 0))
				{
					if (first) { first = 0; } else { printf(" "); }
					printf("XXXX");
				}
				else
				{
					if (first) { first = 0; } else { printf(" "); }
					printf("%04lX", ((b0 & 0x0F) << 12) | ((b1 & 0x3F) << 6) | (b2 & 0x3F));
				}
			}
			else
			{
				if (first) { first = 0; } else { printf(" "); }
				printf("XXXX");
			}
		}

		printf("\n");
		return 0;
	}
	else
	{
		printf("Usage: %s -c NNNN NNNN NNNN ...\n", argv[0]);
		printf("       to compress UCS-2 into UTF-8\n");
		printf("\n");
		printf("       %s -e NN NN NN NN NN NN NN ...\n", argv[0]);
		printf("       to expand UTF-8 into UCS-2\n");
		printf("\n");
		printf("       where N is a hexadecimal digit\n");

		return 1;
	}
}

